//
//  Controller.m
//  OpenURLHatenaRSS
//
//  Created by KOYAMA Yoshiaki on 06/06/30.
//  Copyright 2006 KOYAMA Yoshiaki. All rights reserved.
//

#import "Controller.h"
#import "ItemElement.h"

@implementation Controller

// EBhEƂ̏
- (BOOL)windowShouldClose:(id)sender {
	[NSApp terminate:self];
    return YES;
}

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification {
	
}

- (IBAction)readHatenaRSS:(id)sender {
	NSXMLDocument *xmlDoc = nil;
	NSError *err = nil;
	NSURL *url;
	NSArray *nodes, *array;
	NSString *title, *link, *date, *description;
	int count, i;
	NSString *sourceString, *subString, *resultString, *httpString = @"http";
	NSString *pStr, *version;
	NSRange aRange;
	NSRange range;
	enum rssGenerator generator;

	generator = OTHER;

	sourceString = [_rssField stringValue];

	if ([sourceString isEqualToString:@""] || sourceString == nil) {
		[self openAlert:@"MESSAGE_URL" :@"RSS" :@"INFORMATIVE_URL" :@"INPUT RSS URL" :nil];
		return;

	} else {

		range.location = 0;
		range.length = 4;
		
		// URL̐擪̕ feed ̎ http ɕύX
		if ([sourceString compare:@"feed" options:NSCaseInsensitiveSearch range:range] == NSOrderedSame) {
			range.location = 4;
			range.length = [sourceString length] - 4;

			subString = [sourceString substringWithRange:range];
			sourceString = [httpString stringByAppendingString:subString];
//			NSLog(@"%@", sourceString);
		}

		// 2oCgGXP[vɕϊ
		resultString = (NSString*)CFURLCreateStringByAddingPercentEscapes( NULL, 
				(CFStringRef)sourceString, NULL, CFSTR("+"), CFStringConvertNSStringEncodingToEncoding(NSUTF8StringEncoding));

		// NSURL쐬
		url = [NSURL URLWithString:resultString];
//		url = [NSURL URLWithString:sourceString];

		// sourceString%ꍇ蒼BϊȂURL쐬
		aRange.length = 1;
		for (i=0; i<[sourceString length]; i++) {
			aRange.location = i;
			pStr = [sourceString substringWithRange:aRange];

			if ([pStr isEqualToString:@"\%"] == YES) {
				url = [NSURL URLWithString:sourceString];
				break;
			}
		}
	}

//NSLog(@"%@", url);

	[_indicator startAnimation:self];

	// ͂ĂȂRSS͒ɕR[hG[̂ŁANSXMLDocumentTidyXMLw肵ĕ\ł镶ɕϊĂ炤B
	xmlDoc = [[NSXMLDocument alloc] initWithContentsOfURL:url options:NSXMLDocumentTidyXML error:&err];
//	xmlDoc = [[NSXMLDocument alloc] initWithContentsOfURL:url options:NSXMLDocumentTidyXML|NSXMLDocumentValidate error:&err];
//	xmlDoc = [[NSXMLDocument alloc] initWithContentsOfURL:url options:0 error:&err];
//	xmlDoc = nil;

//NSLog(@"xml %@", xmlDoc);

	if (xmlDoc != nil) {
		nodes = [xmlDoc nodesForXPath:@".//rss" error:&err];

		if ([nodes count] != 0) {
			array = [[nodes objectAtIndex:0] nodesForXPath:@"@version" error:&err];
//			NSLog(@"%@", [array objectAtIndex:0]);

			if ([array count] != 0) {
				version = [[array objectAtIndex:0] stringValue];
				if ([version isEqualToString:@"2.0"] == YES) {
					nodes = [xmlDoc nodesForXPath:@".//rss/channel/item" error:&err];
					generator = RSS2_0;
				} else {
					xmlDoc = nil;
				}
			} else {
				xmlDoc = nil;
			}

		} else {
			nodes = [xmlDoc nodesForXPath:@".//rdf:RDF/item" error:&err];
		}	

//		NSLog(@"%d", [nodes count]);
	}

	if ((xmlDoc == nil) || ([nodes count] == 0)){
		[_indicator stopAnimation:self];

//	NSLog(@"Error code %d", [err code]);
//	NSLog(@"Error domain %@", [err domain]);
//	NSLog(@"Error userInfo %@", [err userInfo]);
//	NSLog(@"Error userInfo %@", [[err userInfo] objectForKey:NSLocalizedDescriptionKey]);

//		[self openAlert:@"MESSAGE_TEXT" :@"RSS" :@"INFORMATIVE_TEXT" :@"NO READ" :nil];
		[self openAlert:@"MESSAGE_TEXT" :@"RSS" :@"INFORMATIVE_TEXT" :@"NO READ" :err]; // G[̏ڍׂ\
		return;
	}  


//	nodes = [xmlDoc nodesForXPath:@".//rdf:RDF/item" error:&err];

	// e[ũf[^ׂď
	[self removeObjects];

	count = [nodes count];

	// f[^e[uɒǉ
	if (count != 0) {
		for (i=0; i<count; i++) {

			array = [[nodes objectAtIndex:i] nodesForXPath:@".//title" error:&err];			
			if ([array count] == 0) {
				title = @"";
			} else {
				title = [[array objectAtIndex:0] stringValue];
//				NSLog(@"title=%@", title);
			}


			array = [[nodes objectAtIndex:i] nodesForXPath:@".//link" error:&err];			
			if ([array count] == 0) {
				link = @"";
			} else {
				link = [[array objectAtIndex:0] stringValue];
//				NSLog(@"link=%@", link);
			}

			if (generator == RSS2_0) {
				array = [[nodes objectAtIndex:i] nodesForXPath:@".//pubDate" error:&err];
			} else {
				array = [[nodes objectAtIndex:i] nodesForXPath:@".//dc:date" error:&err];			
			}
			
			if ([array count] == 0) {
				date = @"";
			} else {
				date = [[array objectAtIndex:0] stringValue];
//				NSLog(@"date=%@", date);
			}

			array = [[nodes objectAtIndex:i] nodesForXPath:@".//description" error:&err];			
			if ([array count] == 0) {
				description = @"";
			} else {
				description = [[array objectAtIndex:0] stringValue];
//				NSLog(@"description=%@", description);
			}

			[self addElement:title :link :date :description];
		}
	}

	[_indicator stopAnimation:self];
}


- (void)alertDidEnd:(NSAlert *)alert returnCode:(int)returnCode  contextInfo:(void  *)contextInfo {
	if (returnCode == NSAlertFirstButtonReturn) {
	}
}

- (IBAction)openURLALL:(id)sender {
	NSArray *array;

	array = [_itemArrayController arrangedObjects];
	[self openURLSelectALL:array :NO :NO];
}

- (IBAction)openURLSelect:(id)sender {
	NSArray *array;
	
	array = [_itemArrayController selectedObjects];
	[self openURLSelectALL:array :YES :NO];
}

- (IBAction)openURLNewALL:(id)sender {
	NSArray *array;

	array = [_itemArrayController arrangedObjects];
	[self openURLSelectALL:array :NO :YES];
}

- (IBAction)openURLNewSelect:(id)sender {
	NSArray *array;
	
	array = [_itemArrayController selectedObjects];
	[self openURLSelectALL:array :YES :YES];
}

- (void)openURLSelectALL:(NSArray *)array :(BOOL)check :(BOOL)newDiary {
	NSWorkspace *wspace = [NSWorkspace sharedWorkspace];
    NSMutableDictionary *properties;
	NSURL *url;
	NSString *urlString;
	ItemElement *element;
	int i;

	for (i=0; i<[array count]; i++) {
		element = [array objectAtIndex:i];

		properties = [element properties];
		urlString = [properties objectForKey:@"link"];
		
		// `FbN͂
		if (check == YES) {
			[properties setValue:[NSNumber numberWithBool:NO] forKeyPath:@"check"];
		}

		if (urlString != nil) {
			// ŐV̓L\
			if (newDiary == YES) {
				url = [NSURL URLWithString:[urlString stringByDeletingLastPathComponent]];
				[wspace openURL:url];
			} else {
			// URL\
				url = [NSURL URLWithString:urlString];
				[wspace openURL:url];
			}
		}
	}
}

- (IBAction)openURL10:(id)sender {
	[self openURLMax:10 :NO];
}

- (IBAction)openURL20:(id)sender {
	[self openURLMax:20 :NO];
}

- (IBAction)openURLNew10:(id)sender {
	[self openURLMax:10 :YES];
}

- (IBAction)openURLNew20:(id)sender {
	[self openURLMax:20 :YES];
}

- (void)openURLMax:(int)max :(BOOL)newDiary {
	NSWorkspace *wspace = [NSWorkspace sharedWorkspace];
    NSMutableDictionary *properties;
	NSURL *url;
	NSString *urlString;
	ItemElement *element;
	NSArray *array;
	int i;
	int count = 0;
	NSNumber *number;

	array = [_itemArrayController arrangedObjects];

	if ([self isCheck:array] == NO) {
		return;
	}

	for (i=0; i<[array count]; i++) {
		element = [array objectAtIndex:i];

		properties = [element properties];
		number = [properties objectForKey:@"check"];

		if ([number boolValue] == YES) {

			urlString = [properties objectForKey:@"link"];
		
			[properties setValue:[NSNumber numberWithBool:NO] forKeyPath:@"check"];

			if (urlString != nil) {
				// ŐV̓L
				if (newDiary == YES) {
					url = [NSURL URLWithString:[urlString stringByDeletingLastPathComponent]];
					[wspace openURL:url];
				} else {
				// URL\
					url = [NSURL URLWithString:urlString];
					[wspace openURL:url];
				}
			}
			count++;
		}
		if (count >= max) {
			break;
		}
	}
}

//`FbNtĂ{^邩
- (BOOL)isCheck:(NSArray *)array {
    NSMutableDictionary *properties;
	ItemElement *element;
	int i;
	NSNumber *number;
	int count = 0;

	for (i=0; i<[array count]; i++) {
		element = [array objectAtIndex:i];

		properties = [element properties];
		number = [properties objectForKey:@"check"];

		if ([number boolValue] == YES) {
			count++;
			break;
		}
	}

	if (count == 0) {
		[self openAlert:@"MESSAGE_DATA" :@"DATA" :@"INFORMATIVE_DATA" :@"NO DATA" :nil];
		return NO;
	} else {
		return YES;
	}
}

- (IBAction)openURLCheckALL:(id)sender {
	[self openURLCheckALLBOOL:NO :NO];
}

- (IBAction)openURLNewCheckALL:(id)sender {
	[self openURLCheckALLBOOL:YES :NO];
}

- (IBAction)openURLCheckALL2:(id)sender {
	[self openURLCheckALLBOOL:NO :YES];
}

- (void)openURLCheckALLBOOL:(BOOL)newDiary :(BOOL)both {
	NSWorkspace *wspace = [NSWorkspace sharedWorkspace];
    NSMutableDictionary *properties;
	NSURL *url;
	NSString *urlString;
	ItemElement *element;
	NSArray *array;
	int i;
	NSNumber *number;

	array = [_itemArrayController arrangedObjects];

	if ([self isCheck:array] == NO) {
		return;
	}

	for (i=0; i<[array count]; i++) {
		element = [array objectAtIndex:i];

		properties = [element properties];
		number = [properties objectForKey:@"check"];

		if ([number boolValue] == YES) {

			urlString = [properties objectForKey:@"link"];
		
			[properties setValue:[NSNumber numberWithBool:NO] forKeyPath:@"check"];

			if (urlString != nil) {
				// ŐV̓L
				if (newDiary == YES) {
					url = [NSURL URLWithString:[urlString stringByDeletingLastPathComponent]];
					[wspace openURL:url];
				} else {
				// URL\
					url = [NSURL URLWithString:urlString];
					[wspace openURL:url];
				}

				// ŐV̓L\
				if (both == YES) {
					url = [NSURL URLWithString:[urlString stringByDeletingLastPathComponent]];
					[wspace openURL:url];
				}
			}
		}
	}
}

// G[
- (void)openAlert:(NSString *)message :(NSString *)defaultMessage :(NSString *)informative :(NSString *)defaultInformative :(NSError *)err {
	NSAlert *alert;

	// pӂĂG[
	if (err != nil) {
		alert = [NSAlert alertWithError:err];
	} else {
	// ō쐬
		alert = [[[NSAlert alloc] init] autorelease];
		[alert setMessageText:NSLocalizedString(message, defaultMessage)];
		[alert setInformativeText:NSLocalizedString(informative, defaultInformative)];
//		[alert setAlertStyle:NSWarningAlertStyle];
//		[alert setAlertStyle:NSInformationalAlertStyle];
		[alert setAlertStyle:NSCriticalAlertStyle];

		[alert addButtonWithTitle:@"OK"];
	}

	// \
	[alert beginSheetModalForWindow:_window modalDelegate:self 
		didEndSelector:@selector(alertDidEnd:returnCode:contextInfo:) contextInfo:nil];
}

// e[uɃf[^ǉ
- (void)addElement:(NSString *)title :(NSString *)link :(NSString *)date :(NSString *)description {	
	ItemElement *element;

	element = [[[ItemElement alloc] initItemElement:title :link :date :[NSNumber numberWithBool:YES] :description] autorelease];
	[_itemArrayController addObject:element];
}

// e[ũf[^ׂď
- (IBAction)clear:(id)sender {
	[self removeObjects];
}

// ׂẴ`FbN͂
- (IBAction)clearCheck:(id)sender {
    NSMutableDictionary *properties;
	ItemElement *element;
	NSArray *array;
	int i;
	NSNumber *number;

	array = [_itemArrayController arrangedObjects];

	for (i=0; i<[array count]; i++) {
		element = [array objectAtIndex:i];

		properties = [element properties];
		number = [properties objectForKey:@"check"];

		if ([number boolValue] == YES) {
			[properties setValue:[NSNumber numberWithBool:NO] forKeyPath:@"check"];

		}
	}
}

// ׂẴ`FbNt
- (IBAction)allCheck:(id)sender {
    NSMutableDictionary *properties;
	ItemElement *element;
	NSArray *array;
	int i;
	NSNumber *number;

	array = [_itemArrayController arrangedObjects];

	for (i=0; i<[array count]; i++) {
		element = [array objectAtIndex:i];

		properties = [element properties];
		number = [properties objectForKey:@"check"];

		if ([number boolValue] == NO) {
			[properties setValue:[NSNumber numberWithBool:YES] forKeyPath:@"check"];

		}
	}
}

// ׂẴ`FbN𔽓]
- (IBAction)allCheckReverse:(id)sender {
    NSMutableDictionary *properties;
	ItemElement *element;
	NSArray *array;
	int i;
	NSNumber *number;

	array = [_itemArrayController arrangedObjects];

	for (i=0; i<[array count]; i++) {
		element = [array objectAtIndex:i];

		properties = [element properties];
		number = [properties objectForKey:@"check"];

		if ([number boolValue] == NO) {
			[properties setValue:[NSNumber numberWithBool:YES] forKeyPath:@"check"];
		} else {
			[properties setValue:[NSNumber numberWithBool:NO] forKeyPath:@"check"];
		}
	}
}

// e[uf[^ׂď
- (void)removeObjects {
	NSArray *objects;
	
	objects = [_itemArrayController arrangedObjects];
	[_itemArrayController removeObjects:objects];
}

// NbN{[hf[^쐬Ae[uɒǉ
- (IBAction)stripUrlAction:(id)sender {
	NSAttributedString *attrStr;
	unsigned int length;
	NSRange aRange;
	int i, j;
	NSURL *url;
    NSPasteboard *board = [NSPasteboard generalPasteboard];
	NSArray *array;
	NSString *type;
	NSString *urlString = @"", *urlAbsoluteString;
	int arrayCount = 0;
	BOOL flag = NO, aFlag = NO;
	NSMutableString *boardMutableString;
	NSString *str, *title;

	array = [board types];
	arrayCount = [array count];

	boardMutableString = [NSMutableString string];

	for (i=0; i<arrayCount; i++) {
		type = [array objectAtIndex:i];      

		if (([type isEqualToString:@"NeXT RTFD pasteboard type"] == YES) ||
		([type isEqualToString:@"NeXT Rich Text Format v1.0 pasteboard type"] == YES)) {
			aFlag = YES;
		}
	}

	if (aFlag == NO) {
		[self openAlert:@"MESSAGE_CLIP" :@"RSS" :@"INFORMATIVE_CLIP" :@"NO READ" :nil];
		return;
	}

	[_clipIndicator startAnimation:self];

	if ([sender tag] == 0) 
		[self removeObjects];

	for (i=0; i<arrayCount; i++) {
		type = [array objectAtIndex:i];      

		if (([type isEqualToString:@"NeXT RTFD pasteboard type"] == YES) && (flag == NO)) {

			attrStr = [[NSAttributedString alloc] initWithRTFD:[board dataForType:@"NeXT RTFD pasteboard type"] documentAttributes:NULL]; 
			str = [attrStr string];

			length = [attrStr length];
			aRange = NSMakeRange(0, 0);
	
			for (j=0; j<length; j++) {
				url = [attrStr attribute:NSLinkAttributeName atIndex:j effectiveRange:&aRange];

				if (url != nil) {
					urlAbsoluteString = [url absoluteString];
					title = [str substringWithRange:aRange];

					if ([urlString isEqualToString:urlAbsoluteString] == NO) {

						[self addElement:title :urlAbsoluteString :@"" :@""];

						urlString = urlAbsoluteString;
//						NSLog(@"%d %@ %@", j, title, url);

						flag = YES;
					}
				}
			}
		} else if (([type isEqualToString:@"NeXT Rich Text Format v1.0 pasteboard type"] == YES) && (flag == NO)) {

			attrStr = [[NSAttributedString alloc] initWithRTF:[board dataForType:@"NeXT Rich Text Format v1.0 pasteboard type"] documentAttributes:NULL]; 
			str = [attrStr string];

			length = [attrStr length];

			aRange = NSMakeRange(0, 0);
	
			for (j=0; j<length; j++) {
				url = [attrStr attribute:NSLinkAttributeName atIndex:j effectiveRange:&aRange];

				if (url != nil) {
					urlAbsoluteString = [url absoluteString];
					title = [str substringWithRange:aRange];

					if ([urlString isEqualToString:urlAbsoluteString] == NO) {

						[self addElement:title :urlAbsoluteString :@"" :@""];

						urlString = urlAbsoluteString;
//						NSLog(@"%d %@ %@", j, title, url);

						flag = YES;
					}	
				}
			}
		}
	}

	[_clipIndicator stopAnimation:self];
}

- (IBAction)eraseRSSField:(id)sender {
	[_rssField setStringValue:@""];
}

// j[RSSI
- (IBAction)popUpButtonRSS:(id)sender {
	int index = 0;
	NSString *formatTitle, *formatURL, *localizedTitle, *localizedURL;
	
	index = [sender indexOfSelectedItem] - 1;

	if (index <= 0)
		return;

	formatTitle = [[NSString alloc] initWithFormat:@"RSS_TITLE%d", index];
	formatURL = [[NSString alloc] initWithFormat:@"RSS_URL%d", index];

	localizedTitle = NSLocalizedString(formatTitle, @"");
	localizedURL = NSLocalizedString(formatURL, @"");

	if ([localizedTitle isEqualToString:@"-"] == YES)
		return;

//	NSLog(@"string %@ %@", format, localized);

	if ([formatURL isEqualToString:localizedURL] == NO)
			[_rssField setStringValue:localizedURL];
}

// j[̒ǉ
- (void)awakeFromNib {
	int i;
	NSString *formatTitle, *formatURL, *localizedTitle, *localizedURL;
	
	// Ô߁A[vɂȂȂ߁Aől100ɂĂ
	for (i=1; i<100; i++) {
		formatTitle = [[NSString alloc] initWithFormat:@"RSS_TITLE%d", i];
		formatURL = [[NSString alloc] initWithFormat:@"RSS_URL%d", i];

		localizedTitle = NSLocalizedString(formatTitle, @"");
		localizedURL = NSLocalizedString(formatURL, @"");

		if ([formatTitle isEqualToString:localizedTitle] == YES) {
			break;
		} else if ([localizedTitle isEqualToString:@"-"] == YES) {
			[[_popUpButton menu] addItem:[NSMenuItem separatorItem]];
		} else {
			[_popUpButton addItemWithTitle:localizedTitle];
		}
	}
}

// j[̗LE
- (BOOL)validateMenuItem:(NSMenuItem *)menuItem {
	NSArray *array;
    BOOL valid = YES;
    SEL action;

    action = [menuItem action];
//	NSLog(@"action %d", action);

    if ((action == @selector(copyTitle:)) || (action == @selector(copyURL:))) {
		array = [_itemArrayController selectedObjects];
		if ((array == nil) || ([array count] == 0)) {
			valid = NO;
		} else {
			valid = YES;
		}
    } else {
//        valid = [super validateMenuItem:menuItem];
	}

    return valid;
}

- (IBAction)copyTitle:(id)sender {
	[self copyTitleURL:@"title"];
}

- (IBAction)copyURL:(id)sender {	
	[self copyTitleURL:@"link"];
}

// NbN{[hɃRs[
- (void)copyTitleURL:(NSString *)keyString {
	NSArray *array;
	NSMutableDictionary *properties;
	NSString *itemString, *sumString;
	ItemElement *element;
	int i, max = 0;

	array = [_itemArrayController selectedObjects];

	if ((array == nil) || ([array count] == 0)) {
		return;
	}

	sumString = [NSString string];
	max = [array count];

	for (i=0; i<max; i++) {
		element = [array objectAtIndex:i];

		properties = [element properties];
		itemString = [properties objectForKey:keyString];

//		NSLog(@"title:%@", itemString);

		if (i == (max-1)) {
			sumString= [sumString stringByAppendingFormat:@"%@", itemString];
		} else {
			sumString= [sumString stringByAppendingFormat:@"%@, ", itemString];
		}
	}
	
	[self copyString:sumString];
}

// ۂ̃Rs[
- (void)copyString:(NSString *)str {
    NSPasteboard *board = [NSPasteboard generalPasteboard];
	NSArray *array;

	if ((str == nil) || ([str isEqualToString:@""] == YES))
		return;

	// Nbv{[hɃRs[
	array = [NSArray arrayWithObject:NSStringPboardType];
	[board declareTypes:array owner:nil];
	[board setString:str forType:NSStringPboardType];
}

@end

// tH[JXO͂
@interface NSView (DefaultFocusRingType)
+ (NSFocusRingType)defaultFocusRingType;
@end

@implementation NSView (DefaultFocusRingType)
+ (NSFocusRingType)defaultFocusRingType
{
    return NSFocusRingTypeNone;
}
@end
